import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import  java.awt.Color;
/**
 * Write a description of class Rain here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Rain extends Actor
{
    private GreenfootImage img;
    private Color myColor;
    private int size;
    private Visualizer myScreen;
    /**
     * Act - do whatever the Bubble wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Rain()
    {
        img = new GreenfootImage(30,30);
        img.setColor(Color.BLUE);
        img.fillOval(0,0,15,15);
        setImage(img);
    }
    public Rain(int newSize, Color newColor, Visualizer newScreen)
    {
        myScreen = newScreen;
        size = newSize;
        myColor = newColor;
        img = new GreenfootImage(size*2,size*2);
        img.setColor(newColor);
        img.fillOval(0,0,size,size);
        setImage(img);
    }  
    
    public void act() 
    {
        fade();
    }    
    public void fade()
    {
        if (myColor.getAlpha() >= 1 )
        {
            myColor = new Color(myColor.getRed(), 
                myColor.getGreen(), 
                myColor.getBlue(), 
                myColor.getAlpha() - 1);
        }         
        updateImage();
        if (myColor.getAlpha() <= 50)
        {
            leaveWaterMark();
            getWorld().removeObject(this);
        }
    }
    public void updateImage()
    {
        img.clear();
        img.setColor(myColor);
        img.fillOval(0,0,size,size);
    }
    public void leaveWaterMark()
    {
        myScreen.getImage().setColor(myColor);
        myScreen.getImage().fillOval(getX(),getY(),size,size);
    }
}
