import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Bubble here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bubble extends Actor
{
    private GreenfootImage img;
    private Color newRBC;
    private int size, cycleColors;
    private boolean waveReverse = false;
    private int waveValue = 0;
    private Key myKey;
    /**
     * Act - do whatever the Bubble wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Bubble()
    {
        img = new GreenfootImage(30,30);
        newRBC= getNewRBC();
        img.setColor(newRBC);
        img.drawOval(0,0,20,20);
        setImage(img);
        cycleColors = 0;
    }

    public Bubble(int newSize, Key k)
    {
        cycleColors = 0;
        myKey = k;
        size = newSize;
        img = new GreenfootImage(size*2,size*2);
        newRBC= getNewRBC();
        img.setColor(newRBC);
        img.drawOval(0,0,size,size);
        setImage(img);
    }    

    public void act() 
    {
        setLocation(getX()-1,getY() - (size / 10));
        //wave();
        size++;
        updateImage();

    }    



    public void wave()
    {
        if (waveReverse)
        {
            waveValue-= 4;
            if (waveValue < -20)
            {
                waveReverse = false;
            }

        }
        if (!waveReverse)
        {
            waveValue+= 4;
            if (waveValue > 20)
            {
                waveReverse = true;
            }
        }
        setLocation(myKey.getX() - waveValue, getY());
    }

    public void updateImage()
    {
        img.clear();
        img = new GreenfootImage(size*2,size*2);
        img.setColor(newRBC);
        img.drawOval(size - 1,size - 1,size,size);
        setImage(img);
    }
    public Color getNewRBC()
    {
        cycleColors = Greenfoot.getRandomNumber(3);
        if (cycleColors == 0) return new Color (200,0,0);
        if (cycleColors == 1) return new Color (0,200,0);
        if (cycleColors == 2) return new Color (255,255,0);
        else return null;
    }

}
