import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Visualizer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Visualizer extends Actor
{
    public static final int HEIGHT = 340;
    private GreenfootImage image;
    private int rainCounter, rainDelay;
    private Color rainColor;
    /**
     * Act - do whatever the Visualizer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Visualizer()
    {
        rainDelay = 10;
        rainColor = new Color(0,0,200,100);
        image = new GreenfootImage("cloudSky.png");
        setImage(image);
        rainCounter = 0;
    }    

    public void act() 
    {
        if (rainCounter > 100) rainCounter = 100;
        if (rainCounter > 0)
        {
            rainDelay--;
            if (rainDelay < 1)
            {
                rainDelay = 10;
                rainCounter--;
                rainScript();
            }
        }
    }    


    /**
     * Play imagery when pressing piano keys.
     *
     * @param k The key that was played.
     */
    public void visualize(Key k)
    {
        // Add visualization code here
        getWorld().addObject(new Balloon(k,this),
                                             k.getX() / 2,
                                            getWorld().getHeight() / 10);
        

    }
    public void rainScript()
    {
        getWorld().addObject(new Rain(Greenfoot.getRandomNumber(100) + 15, rainColor,this),
                    Greenfoot.getRandomNumber(getWorld().getWidth()), 
                    Greenfoot.getRandomNumber(getWorld().getHeight() / 2));
        
    }
    public void moreRain()
    {
        rainCounter += 10;
    }
}
